new;
library option,pgraph;
OptionSet;

Strike = seqa(70,1,61);

let S0 = 100;

Kmin = 70;
SkewMin = -0.01;
Kmax = 0;
SkewMax = 0.0;
if Kmax == 0;
  Skew = Kmin~SkewMin;
else;
  Skew = Kmin~SkewMin |
         Kmax~SkewMax ;
endif;

let K   =  90   100;
let Vol =  0.30 0.25;
let sv = 0.5 0.1 0.1;
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,Skew[.,1],Skew[.,2],sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);
K1 = K; Vol1 = Vol; Smile1 = Smile;

let K   =  105   110;
let Vol =  0.25 0.25;
let sv = 0.5 0.1 0.1;
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,Skew[.,1],Skew[.,2],sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);
K2 = K; Vol2 = Vol; Smile2 = Smile;

Kmin = 70;
SkewMin = -0.001;
Kmax = 0;
SkewMax = 0.0;
if Kmax == 0;
  Skew = Kmin~SkewMin;
else;
  Skew = Kmin~SkewMin |
         Kmax~SkewMax ;
endif;

let K   =  90   100;
let Vol =  0.30 0.25;
let sv = 0.5 0.1 0.1;
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,Skew[.,1],Skew[.,2],sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);
K3 = K; Vol3 = Vol; Smile3 = Smile;

let K   =  105   110;
let Vol =  0.25 0.25;
let sv = 0.5 0.1 0.1;
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,Skew[.,1],Skew[.,2],sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);
K4 = K; Vol4 = Vol; Smile4 = Smile;

Kmin = 70;
SkewMin = -0.02;
Kmax = 0;
SkewMax = 0.0;
if Kmax == 0;
  Skew = Kmin~SkewMin;
else;
  Skew = Kmin~SkewMin |
         Kmax~SkewMax ;
endif;

let K   =  90   100;
let Vol =  0.30 0.25;
let sv = 0.5 0.1 0.1;
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,Skew[.,1],Skew[.,2],sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);
K5 = K; Vol5 = Vol; Smile5 = Smile;

let K   =  105   110;
let Vol =  0.25 0.25;
let sv = 0.5 0.1 0.1;
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,Skew[.,1],Skew[.,2],sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);
K6 = K; Vol6 = Vol; Smile6 = Smile;

graphset;
  begwind;
  window(2,3,0);

    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2; _pframe = 0;
    _paxht = 0.25; _pnumht = 0.22; _ptitlht = 0.30;
    _pltype = 6|1|3;
    _plwidth = 10;
    xlabel("\216Strike K");
    xtics(60,140,20,2);
    ytics(0.20,0.40,0.05,2);

  i = 1;
  setwind(i);
    _pcolor = 9 + i;
    title("\216Sk(70) = -100 bp");
    _psym = K1~Vol1~ones(2,1).*(11~15~9+i~1~0);
    xy(Strike,Smile1);

  i = 2;
  setwind(i);
    _pcolor = 9 + i;
    _psym = K2~Vol2~ones(2,1).*(11~15~9+i~1~0);
    xy(Strike,Smile2);

  i = 3;
  setwind(i);
    title("\216Sk(70) = -10 bp");
    _pcolor = 9 + i;
    _psym = K3~Vol3~ones(2,1).*(11~15~9+i~1~0);
    xy(Strike,Smile3);

  i = 4;
  setwind(i);
    _pcolor = 9 + i;
    _psym = K4~Vol4~ones(2,1).*(11~15~9+i~1~0);
    xy(Strike,Smile4);

  i = 5;
  setwind(i);
    title("\216Sk(70) = -200 bp");
    _pcolor = 9 + i;
    _psym = K5~Vol5~ones(2,1).*(11~15~9+i~1~0);
    xy(Strike,Smile5);

  i = 6;
  setwind(i);
    _pcolor = 9;
    _psym = K6~Vol6~ones(2,1).*(11~15~9~1~0);
    xy(Strike,Smile6);

    graphprt("-c=1 -cf=pdm5.eps");

  endwind;